<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_request".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanRequest".
 *
 * Columns in table "scan_request" available as properties of the model,
 * followed by relations of table "scan_request" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_template_id
 * @property string $scan_template_version
 * @property string $date_added
 * @property string $email
 * @property integer $owner_account_id
 * @property integer $organization_id
 * @property integer $scan_log_id
 * @property integer $scan_report_id
 * @property integer $partner_site_id
 *
 * @property ScanTemplate $scanTemplate
 * @property ScanReport $scanReport
 * @property Account $ownerAccount
 * @property Organization $organization
 */
abstract class BaseScanRequest extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_request';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanRequest|ScanRequests', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('scan_template_id', 'required'),
            array(
                'scan_template_id, owner_account_id, organization_id, scan_log_id, scan_report_id, partner_site_id',
                'numerical',
                'integerOnly' => true
            ),
            array('scan_template_version', 'length', 'max' => 11),
            array('email', 'length', 'max' => 255),
            array('date_added', 'safe'),
            array(
                'date_added, owner_account_id, organization_id, scan_log_id, scan_report_id, partner_site_id',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, scan_template_id, scan_template_version, date_added, email, owner_account_id, organization_id, '
                    . 'scan_log_id, scan_report_id',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'scanTemplate' => array(self::BELONGS_TO, 'ScanTemplate', 'scan_template_id'),
            'scanReport' => array(self::BELONGS_TO, 'ScanReport', 'scan_report_id'),
            'ownerAccount' => array(self::BELONGS_TO, 'Account', 'owner_account_id'),
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'scanLog' => array(self::BELONGS_TO, 'ScanLog', 'scan_log_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_template_id' => null,
            'scan_template_version' => Yii::t('app', 'Scan Template Version'),
            'date_added' => Yii::t('app', 'Date Added'),
            'email' => Yii::t('app', 'Email'),
            'owner_account_id' => null,
            'organization_id' => null,
            'scan_log_id' => null,
            'scan_report_id' => null,
            'partner_site_id' => null,
            'scanTemplate' => null,
            'scanReport' => null,
            'ownerAccount' => null,
            'organization' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_template_id', $this->scan_template_id);
        $criteria->compare('scan_template_version', $this->scan_template_version, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('owner_account_id', $this->owner_account_id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('scan_log_id', $this->scan_log_id);
        $criteria->compare('scan_report_id', $this->scan_report_id);
        $criteria->compare('partner_site_id', $this->partner_site_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
